@echo off

echo Build System
echo ------------

rem -----------------------------------------
rem Set Environmental variables for the Build
rem -----------------------------------------


rem set the ant home directory - where ant is installed
set ANT_HOME=..\lib\ant1.4

rem set the path to the anthill extensions directory
rem you probably need anthill installed on your system
rem set EXT_LIB=..\lib\ext


rem ===============================================
rem check for existence of JAVA_HOME
if "%JAVA_HOME%" == "" goto error


rem ===============================================
set LIB_JARS=

rem add all jar files in %ANT_HOME% directory to LIB_JARS
for %%i in (%ANT_HOME%\*.jar) do call cpappend.bat %%i

rem add all jar files in %EXT_LIB% directory to LIB_JARS
for %%i in (%EXT_LIB%\*.jar) do call cpappend.bat %%i


rem ===============================================
set CLASSPATH=

rem ant requires tools.jar in the classpath
set CLASSPATH=%CLASSPATH%;%JAVA_HOME%\lib\tools.jar

rem add LIB_JARS to CLASSPATH
set CLASSPATH=%CLASSPATH%;%LIB_JARS%


rem ===============================================
set STARTUP_PARAMS=

rem add Butler configuration
set STARTUP_PARAMS=%STARTUP_PARAMS% -Dant.home="%ANT_HOME%" 


rem ===============================================
echo Building with classpath %CLASSPATH%
echo Starting Ant...

%JAVA_HOME%\bin\java %STARTUP_PARAMS% org.apache.tools.ant.Main -buildfile release.xml %1 %2 %3 %4 %5

goto end

:error

echo ERROR: JAVA_HOME not found in your environment.
echo Please, set the JAVA_HOME variable in your environment to match the
echo location of the Java Virtual Machine you want to use.

:end


pause
