/*
 * @(#)BuildDaemon.java
 *
 * License -
 * The contents of this file are subject to the Urbancode Public License
 * Version 1.0 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.urbancode.com/licenses/UPL/1_0/
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations
 * under the License.
 *
 * The Initial Developer of the Original Code is Urbancode Software
 * Development, Inc. ("Urbancode").  Portions created by Urbancode are
 * Copyright (C) Urbancode Software Development, Inc. All Rights Reserved.
 */
package com.urbancode.anthill;
import org.apache.log4j.Category;
import com.urbancode.anthill.util.Queue;
/**
 * @author 
 */
public class BuildDaemon extends Thread {

    //**************************************************************************
    // CLASS
    //**************************************************************************

    // Create Log4j category instance for logging
    static private Category log = Category.getInstance(BuildDaemon.class.getName());
    
    //**************************************************************************
    // INSTANCE
    //**************************************************************************
    protected Queue queue = null;
    protected Buildable projectBeingBuilt = null;

    //--------------------------------------------------------------------------
    public BuildDaemon(Queue queue) {
        this.queue = queue;
    }

    //--------------------------------------------------------------------------
    public Buildable getProjectBeingBuilt() {
        log.debug("getProjectBeingBuilt() : "+projectBeingBuilt);
        return projectBeingBuilt;
    }
    
    //--------------------------------------------------------------------------
    public void run() {
        log.debug("BuildDaemon.run()");
        
        while (true) {
            try {
                projectBeingBuilt = (Buildable)queue.getHead();//buildDef.getProject();
                projectBeingBuilt.run();
                projectBeingBuilt = null;
            } catch (Exception e) {
                log.error(e.getMessage(), e);
            }
        }
    }
    
}
