/*
 * @(#)BuildDefinition.java
 *
 * Copyright (c) 2001 by Lividblue Technologies, Inc., All rights Reserved
 *
 */
package com.urbancode.anthill;
import org.apache.log4j.Category;
import java.util.*;
/**
 * @author 
 */
public class BuildDefinition implements Buildable {

    //**************************************************************************
    // CLASS
    //**************************************************************************

    // Create Log4j category instance for logging
    static private Category log = Category.getInstance(BuildDefinition.class.getName());
    
    //**************************************************************************
    // INSTANCE
    //**************************************************************************
    protected boolean errorFlag = false;
    protected boolean forceBuildFlag = false;
    protected boolean requiresBuildFlag = false;
    protected AnthillProject project = null;
    protected ProjectTarget target = null;
    protected String version = null;
    protected StringBuffer logMessageBuffer = new StringBuffer();
    protected List revisionList = null;

    //--------------------------------------------------------------------------
    public BuildDefinition() {
    }
    
    //--------------------------------------------------------------------------
    public BuildDefinition(AnthillProject project) {
        this.project = project;
    }

    //--------------------------------------------------------------------------
    public void setErrorFlag(boolean errorFlag) {
        this.errorFlag = errorFlag;
    }
    
    //--------------------------------------------------------------------------
    public boolean getErrorFlag() {
        return errorFlag;
    }

    //--------------------------------------------------------------------------
    public void setForceBuildFlag(boolean forceBuildFlag) {
        this.forceBuildFlag = forceBuildFlag;
    }
    
    //--------------------------------------------------------------------------
    public boolean getForceBuildFlag() {
        return forceBuildFlag;
    }
    
    //--------------------------------------------------------------------------
    public void setRequiresBuildFlag(boolean requiresBuildFlag) {
        this.requiresBuildFlag = requiresBuildFlag;
    }
    
    //--------------------------------------------------------------------------
    public boolean getRequiresBuildFlag() {
        return requiresBuildFlag;
    }
    
    //--------------------------------------------------------------------------
    public String getName() {
        String name = null;
        
        if (target != null) {
            name = project.getProjectName() + "." + target.getName();
        } else {
            name = project.getProjectName();
        }
        return name;
    }

    //--------------------------------------------------------------------------
    public void setProject(AnthillProject project) {
        this.project = project;
    }
    
    //--------------------------------------------------------------------------
    public AnthillProject getProject() {
        return project;
    }
    
    //--------------------------------------------------------------------------
    public void setTarget(ProjectTarget target) {
        this.target = target;
    }
    
    //--------------------------------------------------------------------------
    public ProjectTarget getTarget() {
        return target;
    }
    
    //--------------------------------------------------------------------------
    public void setVersion(String version) {
        this.version = version;
    }
    
    //--------------------------------------------------------------------------
    public String getVersion() {
        return version;
    }
        
    //--------------------------------------------------------------------------
    public void doScheduleNameChanged(AnthillSchedule schedule)
    throws Exception {
        project.doScheduleNameChanged(schedule);
    }
    
    //--------------------------------------------------------------------------
    public void setRevisionList(List revisionList) {
        this.revisionList = revisionList;
    }
    
    //--------------------------------------------------------------------------
    public List getRevisionList() {
        return revisionList;
    }

    //--------------------------------------------------------------------------
    public StringBuffer getLogMessageBuffer() {
        return logMessageBuffer;
    }
    
    //--------------------------------------------------------------------------
    public BuildDefinition appendLogMessage(String logMessage) {
        logMessageBuffer.append(logMessage);
        return this;
    }
    
    //--------------------------------------------------------------------------
    public void run() {
        log.debug("running build Def FB flag" +this.getForceBuildFlag());
        project.releaseProject(this);
    }
    
}
