/*
 * @(#)Revision.java
 *
 * License -
 * The contents of this file are subject to the Urbancode Public License
 * Version 1.0 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.urbancode.com/licenses/UPL/1_0/
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations
 * under the License.
 *
 * The Initial Developer of the Original Code is Urbancode Software
 * Development, Inc. ("Urbancode").  Portions created by Urbancode are
 * Copyright (C) Urbancode Software Development, Inc. All Rights Reserved.
 */
package com.urbancode.anthill.adapter;
import org.apache.log4j.Category;
import java.util.Date;
import java.text.SimpleDateFormat;
/**
 * @version $Revision: 1.3 $
 * @author 
 */
public class Revision {

    //**************************************************************************
    // CLASS
    //**************************************************************************

    // Create Log4j category instance for logging
    static private Category log = Category.getInstance(Revision.class.getName());
    
    // date format used for the revision date
    private static final SimpleDateFormat DATE_FORMAT = new SimpleDateFormat("MM/dd/yyyy HH:mm:ss");

    //**************************************************************************
    // INSTANCE
    //**************************************************************************
    public String fileName = null;
    public Date date = null;
    public String comment = null;
    public String userName = null;
    public int linesAdded = 0;
    public int linesDeleted = 0;
    public boolean wasDeleted = false;
    public boolean wasAdded = false;
    
    //--------------------------------------------------------------------------
    public Revision() {
    }

    //--------------------------------------------------------------------------
    public String toString() {
        StringBuffer s = new StringBuffer();
        
        s.append("REVISION: file: ").append(fileName)
         .append(", date: ").append(DATE_FORMAT.format(date))
         .append(", user: ").append(userName);
        
        return s.toString();
    }

}
