/*
 * @(#)FileRemover.java
 *
 * License -
 * The contents of this file are subject to the Urbancode Public License
 * Version 1.0 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.urbancode.com/licenses/UPL/1_0/
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations
 * under the License.
 *
 * The Initial Developer of the Original Code is Urbancode Software
 * Development, Inc. ("Urbancode").  Portions created by Urbancode are
 * Copyright (C) Urbancode Software Development, Inc. All Rights Reserved.
 */
package com.urbancode.anthill.util;

import java.io.File;
/**
 * <p>
 * A utility that deletes a <code>File</code> and if it is a directory, all
 * directories and files underneath it.</p>
 *
 * @version $Revision: 1.5 $
 * @author  Ryan Smith
 */
public class FileRemover {

    //**************************************************************************
    // CLASS
    //**************************************************************************

    /** Removes the file/directory from the system and all files/directories
     *  contained in it.
     * param f  the file/directory to be removed
     */
    public static void removeFile(File f) {
        System.gc();
        privateRemoveFile(f);
    }
    
    private static void privateRemoveFile(File f) {
        if (f.isDirectory()) {
            File files[] = f.listFiles();
            for (int i=0; i<files.length; i++) {
                FileRemover.privateRemoveFile(files[i]);
            }
        }
        f.delete();
    }

    //**************************************************************************
    // INSTANCE
    //**************************************************************************

}
