/*
 * @(#)Queue.java
 *
 * License -
 * The contents of this file are subject to the Urbancode Public License
 * Version 1.0 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.urbancode.com/licenses/UPL/1_0/
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations
 * under the License.
 *
 * The Initial Developer of the Original Code is Urbancode Software
 * Development, Inc. ("Urbancode").  Portions created by Urbancode are
 * Copyright (C) Urbancode Software Development, Inc. All Rights Reserved.
 */
package com.urbancode.anthill.util;
import org.apache.log4j.Category;
import java.util.*;
/**
 * @version $Revision: 1.3 $
 * @author 
 */
public class Queue {

    //**************************************************************************
    // CLASS
    //**************************************************************************

    // Create Log4j category instance for logging
    static private Category log = Category.getInstance(Queue.class.getName());
    
    //**************************************************************************
    // INSTANCE
    //**************************************************************************
    protected List list = new ArrayList();

    //--------------------------------------------------------------------------
    public Queue() {
    }

    public void add(Object o) {
        add(o, true);
    }
    
    synchronized public void add(Object o, boolean coalesce) {
        log.debug("Queue.add() o: "+o);
        
        if (coalesce) {
            if (!list.contains(o)) {
                list.add(o);
            }
        } else {
            list.add(o);
        }   
        notify();
    }
    
    synchronized public Object getHead() {
        Object o = null;
        while (list.size() < 1) {
            try {
                wait();
            } catch (InterruptedException ie) {
                log.error(ie.getMessage(), ie);
            }
        }
        o = list.remove(0);
        log.debug("Queue.getHead() o: "+o);
        return o;
    }
    
    public Iterator getIterator() {
        return list.iterator();
    }
        
}
