/*
 * @(#)ReadSubDirServlet.java
 *
 * License -
 * The contents of this file are subject to the Urbancode Public License
 * Version 1.0 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.urbancode.com/licenses/UPL/1_0/
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations
 * under the License.
 *
 * The Initial Developer of the Original Code is Urbancode Software
 * Development, Inc. ("Urbancode").  Portions created by Urbancode are
 * Copyright (C) Urbancode Software Development, Inc. All Rights Reserved.
 */
 
package com.urbancode.anthill.web;           

import javax.servlet.*;
import javax.servlet.http.*;
import com.urbancode.anthill.web.*;
import java.io.*;
import java.util.*;


/** 
 *
 * @author  matthew
 * @version 
 */
public class ReadSubdirServlet extends HttpServlet {
   
    /** Handles the HTTP <code>GET</code> method.
    * @param request servlet request
    * @param response servlet response
    */
    protected void doGet(HttpServletRequest req, HttpServletResponse res)
    throws ServletException, java.io.IOException {
        
        String url = req.getParameter("url");
        String forwardto = req.getParameter("forwardto");
        String contextPath = req.getContextPath();
//System.out.println("contextPath: "+contextPath);

        String urlWithinContext = url;
        if (urlWithinContext.startsWith(contextPath)) {
            urlWithinContext = urlWithinContext.substring(contextPath.length());
        }
//System.out.println("urlWithinContext: "+urlWithinContext);        
        if (forwardto.startsWith(contextPath)) {
            forwardto = forwardto.substring(contextPath.length());
        }
//System.out.println("forwardto: "+forwardto);        
        
        ServletContext context = getServletContext();
        String realPath = context.getRealPath(urlWithinContext);
//System.out.println("realPath: "+realPath);        
        File path = new File(realPath);
//System.out.println("path: "+path);  

        Subdirectories subdirs = SubdirectoryScanner.scanDirectory(path, url);
        Iterator dirItr = subdirs.getWebDirectoryIterator();
        //set the iterator of subdirectories on the request
        req.setAttribute("urlItr" , dirItr);

        context.getRequestDispatcher(forwardto).forward(req , res);
    }        

    /** Handles the HTTP <code>POST</code> method.
    * @param request servlet request
    * @param response servlet response
    */
    protected void doPost(HttpServletRequest req, HttpServletResponse res)
    throws ServletException, java.io.IOException {
        doGet(req, res);  
    }

    /** Returns a short description of the servlet.
    */
    public String getServletInfo() {
        return "Short description";
    }

}
