/*
 * @(#)SubdirectoryScanner.java
 *
 * License -
 * The contents of this file are subject to the Urbancode Public License
 * Version 1.0 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.urbancode.com/licenses/UPL/1_0/
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations
 * under the License.
 *
 * The Initial Developer of the Original Code is Urbancode Software
 * Development, Inc. ("Urbancode").  Portions created by Urbancode are
 * Copyright (C) Urbancode Software Development, Inc. All Rights Reserved.
 */

package com.urbancode.anthill.web;
    
import java.io.*;
import java.util.*;
/**
 *
 * @author  matthew
 * @version 
 * 
 * */
public abstract class SubdirectoryScanner {
     
    public static Subdirectories scanDirectory(File path, String url) {
        if (path == null) {
            throw new IllegalArgumentException("Path parameter can't be null.");
        }
        if (!path.isDirectory()) {
            throw new IllegalArgumentException("Path parameter must be a directory.");
        }
        if (url == null) {
            throw new IllegalArgumentException("Url parameter can't be null.");
        }
        
        Subdirectories subDir = new Subdirectories();

        // make sure format of url is good - ends with "/"
        if (!url.endsWith("/")) {
            url += "/";
        }
        
        // get array of files
        File[] dir = path.listFiles();
        
        // loop through files
        for (int i=0 ; i < dir.length; i++ ) {
            // check each one to see whether it is a directory
            if (dir[i].isDirectory() && !dir[i].getName().equalsIgnoreCase("WEB-INF")) {
                // if it is a directory, then create a new WebDirectory instance
                WebDirectory webDir = new WebDirectory(dir[i], url + dir[i].getName());

                // and add it to the SubDirectories object
                subDir.addWebDirectory(webDir);
            }
        }
        // return the SubDirectories object
        return subDir;       
    }
}
