/*
 * @(#)AnthillDeleteServlet.java
 *
 * License -
 * The contents of this file are subject to the Urbancode Public License
 * Version 1.0 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.urbancode.com/licenses/UPL/1_0/
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations
 * under the License.
 *
 * The Initial Developer of the Original Code is Urbancode Software
 * Development, Inc. ("Urbancode").  Portions created by Urbancode are
 * Copyright (C) Urbancode Software Development, Inc. All Rights Reserved.
 */

package com.urbancode.anthill.web.admin;           
import org.apache.log4j.Category;
import javax.servlet.*;
import javax.servlet.http.*;
import com.urbancode.anthill.*;
import java.io.PrintWriter;
import java.io.File;

/** 
 *
 * @author  SPB
 * @version 
 */
public class AnthillDeleteServlet extends HttpServlet {

//**************************************************************************
    // CLASS
    //**************************************************************************

    // Create Log4j category instance for logging
    static private Category log = Category.getInstance(AnthillDeleteServlet.class.getName());
   
    //**************************************************************************
    // INSTANCE
    //**************************************************************************
    
    /** Initializes the servlet.
    */  
    public void init(ServletConfig config) throws ServletException {
        super.init(config);
        ServletContext context = config.getServletContext();
        
        // little bit to experiment with here...might not have to do anything
    }
    
    /** Destroys the servlet.
    */  
    public void destroy() {

    }

    /** Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
    * @param request servlet request
    * @param response servlet response
    */
    protected void processRequest(HttpServletRequest req, HttpServletResponse res)
    throws ServletException, java.io.IOException {
        
        ServletContext context = getServletContext();
        String deleteType = req.getParameter(WebKeys.DeleteTypeKey);
        String deleteName = req.getParameter(WebKeys.DeleteNameKey);
        boolean error = false;
        log.debug("processing delete servlet");        
        if ((deleteType == null) || (deleteType.trim().equals("")) ||
            (deleteName == null) || (deleteName.trim().equals(""))) {
                error = true;
        }
        if (!error) {
            Anthill anthill = (Anthill)context.getAttribute(WebKeys.AnthillKey);
            try {
                if (deleteType.equalsIgnoreCase("schedule")) {
                    // only need the config directory here
                    log.debug("deleting schedule");        
                    anthill.deleteSchedule(deleteName);
                }
                else if (deleteType.equalsIgnoreCase("dependencyGroup")) {
                    // here you just need the projects folder
                    log.debug("deleting group");        
                    anthill.deleteDependencyGroup(deleteName);
                }
                else if (deleteType.equalsIgnoreCase("project")) {
                    log.debug("deleting project");        
                    anthill.deleteProject(deleteName);
                }
                else {
                    // this is a problem
                    log.debug("<BR> DeleteType not defined: " + deleteType);
                    error = true;
                }       
            }
            catch (Exception e) {
                log.debug(e.getMessage() + " thrown in deleteServlet");
                error = true;
            }
    
            req.setAttribute(WebKeys.AnthillKey, anthill);
        }
        if (!error) {
            context.getRequestDispatcher(ScreenNames.mainScreen).forward(req, res);
        }
        else {
            context.getRequestDispatcher(ScreenNames.errorScreen).forward(req , res);
        }
    } 

    /** Handles the HTTP <code>GET</code> method.
    * @param request servlet request
    * @param response servlet response
    */
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, java.io.IOException {
        processRequest(request, response);
    } 

    /** Handles the HTTP <code>POST</code> method.
    * @param request servlet request
    * @param response servlet response
    */
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, java.io.IOException {
        processRequest(request, response);
    }

    /** Returns a short description of the servlet.
    */
    public String getServletInfo() {
        return "Short description";
    }

}