/*
 * @(#)BuildDependencyGroupStepOneServlet.java
 *
 * Copyright (c) 2002 by Urbancode Software Development, Inc., All rights Reserved
 *
 */
package com.urbancode.anthill.web.admin;
import org.apache.log4j.Category;
import javax.servlet.*;
import javax.servlet.http.*;
import com.urbancode.anthill.*;
/**
 * @version $Revision: 1.2 $
 * @author
 */
public class BuildDependencyGroupStepOneServlet extends HttpServlet {
    
    //**************************************************************************
    // CLASS
    //**************************************************************************
    
    // Create Log4j category instance for logging
    static private Category log = Category.getInstance(BuildDependencyGroupStepOneServlet.class.getName());
    
    //**************************************************************************
    // INSTANCE
    //**************************************************************************
    
    /** Initializes the servlet.
    */  
    public void init(ServletConfig config) throws ServletException {
        super.init(config);
    }

    /** Destroys the servlet.
    */  
    public void destroy() {

    }

    /** Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
    * @param request servlet request
    * @param response servlet response
    */
    protected void processRequest(HttpServletRequest req, HttpServletResponse res)
    throws ServletException, java.io.IOException {
        ServletContext context = getServletContext();
        Anthill anthill = (Anthill)context.getAttribute(WebKeys.AnthillKey);
        DependencyGroup group = null;
        String groupName = req.getParameter(WebKeys.DependencyGroupNameKey);
        boolean error = false;
        if (groupName != null) {
            group = anthill.getDependencyGroup(groupName);
            if (group != null) {
                req.setAttribute(WebKeys.DependencyGroupKey, group);
            } else {
                error = true;
            }
        } else {
            error = true;
        }
        
        if (error) {
            context.getRequestDispatcher(ScreenNames.errorScreen).forward(req , res);
        } else {
            context.getRequestDispatcher(ScreenNames.buildDependencyGroupScreen).forward(req , res);
        }
    } 

    /** Handles the HTTP <code>GET</code> method.
    * @param request servlet request
    * @param response servlet response
    */
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, java.io.IOException {
        processRequest(request, response);
    } 

    /** Handles the HTTP <code>POST</code> method.
    * @param request servlet request
    * @param response servlet response
    */
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, java.io.IOException {
        processRequest(request, response);
    }

    /** Returns a short description of the servlet.
    */
    public String getServletInfo() {
        return "Short description";
    }

}
