/*
 * @(#)BuildDependencyGroupStepTwoServlet.java
 *
 * Copyright (c) 2002 by Urbancode Software Development, Inc., All rights Reserved
 *
 */
package com.urbancode.anthill.web.admin;
import org.apache.log4j.Category;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;
import com.urbancode.anthill.*;
import com.urbancode.anthill.util.*;
/**
 * @version $Revision: 1.4 $
 * @author
 */
public class BuildDependencyGroupStepTwoServlet extends HttpServlet {
    
    //**************************************************************************
    // CLASS
    //**************************************************************************
    
    // Create Log4j category instance for logging
    static private Category log = Category.getInstance(BuildDependencyGroupStepTwoServlet.class.getName());
    
    //**************************************************************************
    // INSTANCE
    //**************************************************************************
    
    /** Initializes the servlet.
    */  
    public void init(ServletConfig config) throws ServletException {
        super.init(config);
    }

    /** Destroys the servlet.
    */  
    public void destroy() {

    }

    /** Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
    * @param request servlet request
    * @param response servlet response
    */
    protected void processRequest(HttpServletRequest req, HttpServletResponse res)
    throws ServletException, java.io.IOException {
        ServletContext context = getServletContext();
        Anthill anthill = (Anthill)context.getAttribute(WebKeys.AnthillKey);
        Queue buildQueue = anthill.getBuildQueue();
        DependencyGroup group = null;
        String groupName = req.getParameter(WebKeys.DependencyGroupNameKey);
        boolean error = false;
        String propName = null;
        String propValue = null;
        DependencyGroup.Member member = null;

        if (groupName != null) {
            group = anthill.getDependencyGroup(groupName);
            if (group == null) {
                error = true;
            } else {
                // first disable forced build on all members
                Iterator memberItr = group.getMemberIterator();
                while (memberItr.hasNext()) {
                    member = (DependencyGroup.Member)memberItr.next();
                    member.getBuildDefinition().setForceBuildFlag(false);
                }
                
                Enumeration propNameEnum = req.getParameterNames();
                while (propNameEnum.hasMoreElements()) {
                    propName = (String)propNameEnum.nextElement();
                    if (propName.startsWith("force_")) {
                            propValue = req.getParameter(propName);
                            member = group.getMember(propValue);
                            member.getBuildDefinition().setForceBuildFlag(true);
                    }
                }
            }
        } else {
            error = true;
        }
        
        if (!error) {
            buildQueue.add(group);
        }
        
        if (!error) {
            req.setAttribute(WebKeys.DependencyGroupKey, group);
            context.getRequestDispatcher(ScreenNames.AnthillAdminServlet).forward(req , res);
        } else {
            context.getRequestDispatcher(ScreenNames.errorScreen).forward(req , res);
        }
    } 

    /** Handles the HTTP <code>GET</code> method.
    * @param request servlet request
    * @param response servlet response
    */
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, java.io.IOException {
        processRequest(request, response);
    } 

    /** Handles the HTTP <code>POST</code> method.
    * @param request servlet request
    * @param response servlet response
    */
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, java.io.IOException {
        processRequest(request, response);
    }

    /** Returns a short description of the servlet.
    */
    public String getServletInfo() {
        return "Short description";
    }

}
