/*
 * @(#)DependencyGroupPropertiesUpdateServlet.java
 *
 * Copyright (c) 2002 by Urbancode Software Development, Inc., All rights Reserved
 *
 */
package com.urbancode.anthill.web.admin;
import org.apache.log4j.Category;
import javax.servlet.*;
import javax.servlet.http.*;
import com.urbancode.anthill.*;
import java.util.*;
/**
 * @version $Revision: 1.2 $
 * @author
 */
public class DependencyGroupPropertiesUpdateServlet extends HttpServlet {
    
    //**************************************************************************
    // CLASS
    //**************************************************************************
    
    // Create Log4j category instance for logging
    static private Category log = Category.getInstance(DependencyGroupPropertiesUpdateServlet.class.getName());
    
    //**************************************************************************
    // INSTANCE
    //**************************************************************************
    
    /** Initializes the servlet.
    */  
    public void init(ServletConfig config) throws ServletException {
        super.init(config);
    }

    /** Destroys the servlet.
    */  
    public void destroy() {

    }

    /** Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
    * @param request servlet request
    * @param response servlet response
    */
    protected void processRequest(HttpServletRequest req, HttpServletResponse res)
    throws ServletException, java.io.IOException {
        ServletContext context = getServletContext();
        Anthill anthill = (Anthill)context.getAttribute(WebKeys.AnthillKey);
        DependencyGroup group = null;
        String groupName = req.getParameter(WebKeys.DependencyGroupNameKey);
        log.debug("groupName: "+groupName);
        boolean error = false;

        if (groupName != null) {
            group = anthill.getDependencyGroup(groupName);
            if (group == null) {
                error = true;
            }
        } else {
            error = true;
        }
        
        if (!error) {
            synchronized (group) {
                Enumeration propNameEnum = req.getParameterNames();
                DependencyGroup.Member member = null;
                DependencyGroup.Member depMember = null;
                ProjectTarget target = null;
                String memberName = null;
                String depName = null;
                int pos = -1;
                int pos2 = -1;
                AnthillProject project = null;
                AnthillSchedule schedule = null;
                String propName = null;
                String propValue = null;
                while (propNameEnum.hasMoreElements()) {
                    propName = (String)propNameEnum.nextElement();
                    propValue = req.getParameter(propName);
                    
                    // do the project name
                    if (propName.equals("group.name")) {
                        group.setName(propValue);
                    }
                                     
                    // checked box for deleting member
                    if (propName.startsWith("delete.member")) {
                        log.debug("deleting member: "+propValue);
                        member = (DependencyGroup.Member) group.getMember(propValue);
                        group.deleteMember(member);
                    }                    
                    
                    // checked box for deleting dependecies
                    if (propName.startsWith("delete.dependency")) {
                        log.debug("deleting dependency: "+propValue);
                        pos = propValue.indexOf('.');
                        memberName = propValue.substring(0, pos);
                        depName = propValue.substring(pos+1);
                        member = (DependencyGroup.Member) group.getMember(memberName);
                        depMember = member.getDependency(depName);
                        member.deleteDependency(depMember);
                    }                    

                    // creating dependy
                    if (propName.startsWith("create.dependency") && 
                        propValue != null && !propValue.equals("")) {
                            
                        log.debug("creating dependency: "+propValue);
                        pos = propValue.indexOf('.');
                        memberName = propValue.substring(0, pos);
                        depName = propValue.substring(pos+1);
                        member = (DependencyGroup.Member) group.getMember(memberName);
                        depMember = (DependencyGroup.Member) group.getMember(depName);
                        member.addDependency(depMember);
                    }                    

                    // creating member
                    if (propName.startsWith("create.member") && 
                        propValue != null && !propValue.equals("")) {
                            
                        log.debug("creating member: "+propValue);
                        project = anthill.getProject(propValue);
                        group.createNewMember(project);
                    }                    

                    // dependency target
/*
                    if (propName.startsWith("target.")) {
                        log.debug("setting target: " +propValue);
                        pos = propName.indexOf('.', 7);
                        pos2 = propName.indexOf('.', pos);
                        memberName = propName.substring(pos + 1, pos2);
                        depName = propName.substring(pos2 + 1);
                        member = (DependencyGroup.Member) group
                            .getMember(memberName);
                        depMember = (DependencyGroup.Member) group
                            .getMember(depName);
                        target = new ProjectTarget(
                            depMember.getProject(), propValue);
                        depMember.setProjectTarget(target);
                    }
*/
                    
                    // select schedule
                    if (propName.startsWith("group.schedule") && 
                        propValue != null && !propValue.equals("")) {
                        log.debug("setting schedule: "+propValue);
                        schedule = anthill.getSchedule(propValue);
                        group.setSchedule(schedule);
                    }                    

                }
                try {
                    group.save();
                } catch (Exception e) { 
                    log.error(e.getMessage(), e);
                    error = true;
                }
            }
        }
         
        if (!error) {
            context.getRequestDispatcher(ScreenNames.AnthillAdminServlet).forward(req , res);
        } else {
            context.getRequestDispatcher(ScreenNames.errorScreen).forward(req , res);
        }
    } 

    /** Handles the HTTP <code>GET</code> method.
    * @param request servlet request
    * @param response servlet response
    */
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, java.io.IOException {
        processRequest(request, response);
    } 

    /** Handles the HTTP <code>POST</code> method.
    * @param request servlet request
    * @param response servlet response
    */
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, java.io.IOException {
        processRequest(request, response);
    }

    /** Returns a short description of the servlet.
    */
    public String getServletInfo() {
        return "Short description";
    }

}
