<%@ page contentType="text/html"%>
<%@ page import="com.urbancode.anthill.*" %>
<%@ page import="com.urbancode.anthill.util.*" %>
<%@ page import= "com.urbancode.anthill.web.admin.WebKeys" %>
<%@ page import= "java.util.Iterator" %>
<html>
<head><title>Anthill Administration</title></head>
<body>
<%
  Anthill anthill = (Anthill)request.getAttribute(WebKeys.AnthillKey);
  Iterator projectItr = anthill.getProjectIterator();
  Iterator scheduleItr = anthill.getScheduleIterator();
  Iterator groupItr = anthill.getDependencyGroupIterator();
%>
<h2 align="center">Welcome to the Anthill Build System</h2>

<p align="center"><a href="<%= request.getContextPath() %>/AnthillAdminServlet">Refresh</a></p>
<br>
<table border="1" width="400" align="center" cellpadding="3" cellspacing="0">
  <tr bgcolor="gray">
    <td align="left"><a href="<%= request.getContextPath() %>/AnthillPropertiesViewServlet">Anthill Properties</a></td>
  </tr>
</table>
<br>
<!-- ===========================================================================
      PROJECTS
     ======================================================================= -->
<table border="1" width="400" align="center" cellpadding="3" cellspacing="0">
  <tr bgcolor="gray">
    <td colspan="4">Projects</td>
  </tr>
<%
  AnthillProject project = null;
  while (projectItr.hasNext()) {
    project = (AnthillProject)projectItr.next();
    if (!Anthill.NEW_PROJECT_KEY.equals(project.getProjectName())) {

      String projectURL = project.getProperties().getPublishUrl();
      if (projectURL == null || projectURL.equals("")) {
        projectURL = request.getContextPath() + "/projects/" + project.getProjectName();
      } else if (!projectURL.startsWith("http")) {
        projectURL = request.getContextPath() + "/" + projectURL;
      }
%>
  <tr bgcolor="white">
    <td align="left"><a href="<%= request.getContextPath() %>/ProjectPropertiesViewServlet?ProjectName=<%= project.getProjectName() %>"><%= project.getProjectName() %></a></td>
    <td align="center"><a href="<%= projectURL %>">site</a></td>
    <td align="center"><a href="<%= request.getContextPath() %>/BuildProjectStepOneServlet?ProjectName=<%= project.getProjectName() %>">Build</a></td>

    <td align="center"><a href="javascript:void()" onClick='if (confirm("Are you sure?")) { this.href="<%= request.getContextPath() %>/AnthillDeleteStepOneServlet?DeleteType=Project&DeleteName=<%= project.getProjectName() %>";}'>Delete</a></td>

  </tr>
<%
    }
  }
%>
  <tr bgcolor="white">
    <td colspan="4"><a href="<%= request.getContextPath() %>/CreateProjectServlet">Create New Project</a></td>
  </tr>
</table>

<br>
<!-- ===========================================================================
      DEPENDENCY_GROUPS
     ======================================================================= -->
<table border="1" width="400" align="center" cellpadding="3" cellspacing="0">
  <tr bgcolor="gray">
    <td colspan="3">Dependency Groups</td>
  </tr>
<%
  DependencyGroup group = null;
  while (groupItr.hasNext()) {
    group = (DependencyGroup) groupItr.next();
    if (!Anthill.NEW_DEPENDENCY_GROUP_KEY.equals(group.getName())) {
%>
  <tr bgcolor="white">
    <td align="left"><a href="<%= request.getContextPath() %>/DependencyGroupPropertiesViewServlet?DependencyGroupName=<%= group.getName() %>"><%= group.getName() %></a></td>
    <td align="center"><a href="<%= request.getContextPath() %>/BuildDependencyGroupStepOneServlet?DependencyGroupName=<%= group.getName() %>">Build</a></td>
    <td align="center"><a href="javascript:void()" onClick='if (confirm("Are you sure?")) { this.href="<%= request.getContextPath() %>/AnthillDeleteStepOneServlet?DeleteType=DependencyGroup&DeleteName=<%= group.getName() %>";}'>Delete</A></td>

  </tr>
<%
    }
  }
%>
  <tr bgcolor="white">
    <td colspan="3"><a href="<%= request.getContextPath() %>/CreateDependencyGroupServlet">Create New Dependency Group</a></td>
  </tr>
</table>

<br>
<!-- ===========================================================================
      SCHEDULES
     ======================================================================= -->
<table border="1" width="400" align="center" cellpadding="3" cellspacing="0">
  <tr bgcolor="gray">
    <td align="left">Schedules</td>
    <td align="center">Minutes to next build</a></td>
    <td align="center">Delete Schedule</a></td>
  </tr>
<%
  Iterator projItr = null;
  AnthillSchedule schedule = null;
  while (scheduleItr.hasNext()) {
    schedule = (AnthillSchedule)scheduleItr.next();
    if (!Anthill.NEW_PROJECT_KEY.equals(schedule.getScheduleName())) {
%>
  <tr bgcolor="white">
    <td align="left"><a href="<%= request.getContextPath() %>/ScheduleViewServlet?ScheduleName=<%= schedule.getScheduleName() %>"><%= schedule.getScheduleName() %></a></td>
    <td align="center"><%= schedule.getTimeToNextBuild() %></a></td>
    <td align="center"><a href="javascript:void()" onClick='if (confirm("Are you sure? ")) {this.href="<%= request.getContextPath() %>/AnthillDeleteStepOneServlet?DeleteType=Schedule&DeleteName=<%= schedule.getScheduleName() %>";}'>Delete</a></td>                                                                     

  </tr>
<%       
    }
  }
%>
  <tr bgcolor="white">
    <td colspan="3"><a href="<%= request.getContextPath() %>/CreateScheduleServlet">Create New Schedule</a></td>
  </tr>
</table>

<br>
<!-- ===========================================================================
      BUILD QUEUE
     ======================================================================= -->
<table border="1" width="400" align="center" cellpadding="3" cellspacing="0">
  <tr bgcolor="gray">
    <td align="left">Build Queue</td>
  </tr>
<%
  Buildable beingBuilt = anthill.getProjectBeingBuilt();
  if (beingBuilt != null) {
%>
  <tr bgcolor="white">
    <td align="left"><%= beingBuilt.getName() %> -- Being built</td>
  </tr>
<%
  }
%>
<%
  Buildable buildable = null;
  Queue buildQueue = anthill.getBuildQueue();
  Iterator buildItr = buildQueue.getIterator();
  while (buildItr.hasNext()) {
    buildable = (Buildable)buildItr.next();
    if (!Anthill.NEW_PROJECT_KEY.equals(buildable.getName())) {
%>
  <tr bgcolor="white">
    <td align="left"><%= buildable.getName() %></td>
  </tr>
<%
    }
  }
%>
</table>

<p><hr align="center" width="80%"><center><font size="1" face="Arial, Helvetica, sans-serif">Anthill version <%= Anthill.getVersion() %></font></center></p>

</body>
</html>