<%@ page contentType="text/html"%>
<%@ page import="com.urbancode.lib.registry.RegistryEntry" %>
<%@ page import="com.urbancode.anthill.*" %>
<%@ page import= "com.urbancode.anthill.web.admin.WebKeys" %>
<%@ page import= "java.util.*" %>
<html>
<head><title>Project Properties</title></head>
<body>
<%
  Anthill anthill = (Anthill)request.getAttribute(WebKeys.AnthillKey);
  AnthillProject project = (AnthillProject)request.getAttribute(WebKeys.ProjectKey);
  ProjectProperties properties = project.getProperties();

  String projectName = project.getProjectName();
  if (projectName == null) projectName = "";

  String versionAdapter = properties.getVersionAdapterName();
  if (versionAdapter == null) versionAdapter = "";

//  String versionFile = properties.getVersionFilePath();
//  if (versionFile == null) versionFile = "";

  String buildScript = properties.getBuildScriptPath();
  if (buildScript == null) buildScript = "";

  String publishDir = properties.getPublishDir();
  if (publishDir == null) publishDir = "";

  String publishScript = properties.getPublishScriptPath();
  if (publishScript == null) publishScript = "";

  String projectURL = properties.getPublishUrl();
  if (projectURL == null) projectURL = "";

  String repositoryAdapter = properties.getRepositoryAdapterName();
  if (repositoryAdapter == null) repositoryAdapter = "";

%>

<h2 align="center"><%= projectName %> Properties</h2>

<form action="ProjectPropertiesUpdateServlet" method="POST">
<input type="hidden" 
       name="<%= WebKeys.ProjectNameKey %>"
       value="<%= projectName %>">
<table align="center" cellpadding="3" cellspacing="0" width="600">
  <tr bgcolor="#EEEEEE">
    <td colspan="3">
    The name of this project.
    </td>
  </tr>
  <tr bgcolor="white">
    <td width="140">anthill.project.name</td>
    <td align="left" width="460"colspan="2">
      <input type="text" 
             name="project.name" 
             value="<%= projectName %>"
             size="72">
    </td>
  </tr>
  <tr bgcolor="#EEEEEE">
    <td colspan="3">
    The class name of the version adapter.  Right now only the 
    UrbanCodeVersionAdapter is implemented so do not change this value.
    </td>
  </tr>
  <tr bgcolor="white">
    <td width="150">anthill.version.adapter</td>
    <td align="left" colspan="2">
      <input type="text" 
             name="version.adapter" 
             value="<%= versionAdapter %>"
             size="72">
      <a href="VersionAdapterPropertiesViewServlet?ProjectName=<%=projectName%>">Configure <%=project.getProperties().getVersionAdapterName()%></a>
    </td>
  </tr>
<!--
  <tr bgcolor="#EEEEEE">
    <td colspan="3">
    The path of the version file relative to the project root.  The version 
    file must be in CVS.  The version file is a text file that contains the 
    version of the project.  For example, a text file that contains the string
    &quot;1.0.5&quot;.
    </td>
  </tr>
  <tr bgcolor="white">
    <td width="150">anthill.version.file</td>
    <td align="left" colspan="2">
      <input type="text" 
             name="version.file" 
             value="< versionFile >"
             size="72">
    </td>
  </tr>
-->
  <tr bgcolor="#EEEEEE">
    <td colspan="3">
    The class name of the repository adapter.  The repository adapter is 
    responsible for interaction with the source control repository.  
    Currently only the CVSRepositoryAdapter is implemented so do not 
    change this value.
    </td>
  </tr>
  <tr bgcolor="white">
    <td>anthill.repository.adapter</td>
    <td align="left" colspan="2">
      <input type="text" 
             name="repository.adapter" 
             value="<%= repositoryAdapter %>"
             size="72">
      <a href="RepositoryPropertiesViewServlet?ProjectName=<%=projectName%>">Configure <%=project.getProperties().getRepositoryAdapterName()%></a>
    </td>

  </tr>

  <tr bgcolor="#EEEEEE">
    <td colspan="3">
    The paths to the build script relative to the project root directory.
    </td>
  </tr>
  <tr bgcolor="white">
    <td>anthill.build.script</td>
    <td align="left" colspan="2">
      <input type="text" 
             name="build.script" 
             value="<%= buildScript %>"
             size="72">
    </td>
  </tr>
  <tr bgcolor="#EEEEEE">
    <td colspan="3">
    The paths to the publish script relative to the project root directory.
    (In the near future, we are going to get rid of the publish script.  
    Publishing of the projects will still be possible but will need to take 
    place in the main build script.)
    </td>
  </tr>
  <tr bgcolor="white">
    <td>anthill.publish.script</td>
    <td align="left" colspan="2">
      <input type="text" 
             name="publish.script" 
             value="<%= publishScript %>"
             size="72">
    </td>
  </tr>
  <tr bgcolor="#EEEEEE">
    <td colspan="3">
    The path to which the build artifacts are to be moved.  Most of the time 
    you can leave this empty.  Anthill will then place all publish artifacts 
    in the publishDir/${project.name} directory under the Anthill root.  This 
    will by default allow Anthill to make the project artifacts available via 
    a browser at the url: &lt;anthill.server&gt;/anthill/projects/${project.name}.
    </td>
  </tr>
  <tr bgcolor="white">
    <td>anthill.publish.dir</td>
    <td align="left" colspan="2">
      <input type="text" 
             name="publish.dir" 
             value="<%= publishDir %>"
             size="72">
    </td>
  </tr>
  <tr bgcolor="#EEEEEE">
    <td colspan="3">
    The url at which the build artifacts are available.  Most of the time 
    you can leave this empty.  See description of anthill.publish.dir.
    </td>
  </tr>
  <tr bgcolor="white">
    <td>anthill.publish.url</td>
    <td align="left" colspan="2">
      <input type="text" 
             name="publish.url" 
             value="<%= projectURL %>"
             size="72">
    </td>
  </tr>
  <tr bgcolor="#EEEEEE">
    <td colspan="3">
    The email address(es) to send build logs to.  The first input field is the 
    user's name and the second is their email address.
    </td>
  </tr>

    <%
    Map userMap = properties.getNotificationUserMap();
    Iterator userItr = null;
    String userName = null;
    int count = 0;
    userItr = userMap.keySet().iterator();
    if (userItr != null) {
        while (userItr.hasNext()) {
            count++;
            userName = (String)userItr.next();
            String userValue = (String)userMap.get(userName);
            if (userValue == null) userValue = "";
            %>
            <tr bgcolor="white">
                <td>anthill.users.</td>
                <td align="left" width="270"><%= userName %> = <%= userValue %></td>
                <td align="left" width="190">delete
                    <input type=checkbox 
                         name ="<%="remove"+count%>"
                         value= "<%= userName %>"> 
                </td>
            </tr>
            <%
        }
    }
    %>
  <tr bgcolor="white">
    <td>anthill.users</td>
    <td align="left" colspan="2">
      <input type=text
             name ="newUserName"
             value= ""
             size="20">  

       <input type=text
              name = "newUserValue"
              value=""
              size="47">
    </td>    
  </tr>
  <tr bgcolor="#EEEEEE">
    <td colspan="3">
    Parameters to be passed to Ant during the build process.
    </td>
  </tr>
    <%

     List buildParams = properties.getBuildAntParams();
     Iterator keyItr = buildParams.iterator();

     while (keyItr.hasNext()) {
        String paramValue = (String)keyItr.next();
        // paramValue can't be null
    %>
  <tr bgcolor="white">
    <td>anthill.build.ant.params</td>
    <td align="left" width="270"><%= paramValue %></td>
    <td align="left" width="190">delete
        <input type=checkbox 
             name ="<%="deleteBAnt"+paramValue%>"
             value= "<%= paramValue %>"> 

    </td>
  </tr>
    <%
        }
     

     %>
  <tr bgcolor="white">
    <td>anthill.build.ant.params</td>
    <td align="left" colspan="2">
      <input type=text
             name ="newBuildAntParamValue"
             value= ""
             size="72">  
    </td>    
  </tr>
  

  <tr bgcolor="#EEEEEE">
    <td colspan="3">
    Parameters to be passed to Ant during the publish process.
    </td>
  </tr>
    <%

     List publishParams = properties.getPubAntParams();
     keyItr = publishParams.iterator();
     while (keyItr.hasNext()) {
        String paramValue = (String)keyItr.next();
       
    %>
  <tr bgcolor="white">
    <td>anthill.publish.ant.params</td>
    <td align="left" width="270"><%= paramValue %></td>
    <td align="left" width="190">delete
        <input type=checkbox 
             name ="<%="deletePAnt"+paramValue %>"
             value= "<%= paramValue %>"> 

    </td>
  </tr>
    <%
        }
     

     %>
  <tr bgcolor="white">
    <td>anthill.publish.ant.params</td>
    <td align="left" colspan="2">
      <input type=text
             name ="newPublishAntParamValue"
             value= ""
             size="72">  
    </td>    
  </tr>

    <tr bgcolor="white">
    <td>anthill.schedule</td>
    <td align="left">
      <select name="schedule">
        <%
        Iterator scheduleItr = anthill.getScheduleIterator();
        String scheduleName = null;
        AnthillSchedule schedule = properties.getSchedule();     
        String projectScheduleName = null;
        if (schedule != null) {
            projectScheduleName = schedule.getScheduleName();
        }
        
        while (scheduleItr.hasNext()) {
          schedule = (AnthillSchedule)scheduleItr.next();
          scheduleName = schedule.getScheduleName();
        %>
          <option value="<%= scheduleName %>"
                  <% if (scheduleName.equals(projectScheduleName)) {
                       out.write("selected");
                     } %>
                  ><%= scheduleName %></option>
        <%
        }
        %>
      </select>
    </td>    <td></td>
  </tr>
  <tr bgcolor="white">
    <td colspan="2"><input type="submit" name="Update" value="Update"></td>
  </tr>
</table>
</form>

<p><hr align="center" width="80%"><center><font size="1" face="Arial, Helvetica, sans-serif">Anthill version <%= Anthill.getVersion() %></font></center></p>

</table>
</body>
</html>
